/*
 * human.c 緊急停止用プログラム。一部割り込み禁止領域(未チェック)を含む。
 * Creation date : NOT SHIPD     Auther : 渡邊敬矢  
 * v0.1
 */

#include <stdio.h>
#include <time.h>
#include "human.h"
#include "io.h"
#include "uss.h"

extern enum state;

//1.ポーリング割り込みなどで呼び出しされる
int emergency_stop(int stop_type)
{
    __DI();//割り込み禁止
    //2.関数に入った時刻を記録
    int iBeforetime = time();
    //4.getでarduinoの状態を取得する
    //4.呼び出し元の非常停止の動作に応じて挙動を変更させる。
    switch(stop_type){
        case USS:
            //arduinoに停止の信号を送信する。
            while(iBeforetime+10>time()){
                //5.USS信号が規定値を上回った時に元の作業に戻る
                if(20<uss_get_r()||20<uss_get_l())
                {
                    return 1;
                    //setで指令地をarduinoに送る
                }
            }
            state = HOMING;
            return 0;
        case TOUCH:
            
            //arduinoに停止の信号を送信する。
            while(iBeforetime+10>time()){
                //5.タッチセンサが反応したとき元の作業に戻る
                io_get_sw(int sw_f,int sw_l,int sw_r)
                if(!sw_f && !sw_l && !sw_r)
                {
                    return 1;
                }
            }
            state = HOMING;
            return 0;
        case PWR_SW:
            
            //arduinoに停止の信号を送信する。
            while(iBeforetime+3>time())
            {
                //5.電源ボタンが押されたときは3秒で強制的にＨＯＭＩＮＧする
            }
            state = HOMING;
            return 0;
    __EI();
    }
}